import { AppPage } from "./app.po";
import {
  browser,
  by,
  element,
  ElementFinder,
  logging,
  protractor,
} from "protractor";

describe("workspace-project Test Page Null capability", () => {
  let page: AppPage;

  beforeEach(() => {
    page = new AppPage();
    page.navigateToWorkspacesHome();
    expect(browser.getCurrentUrl()).toBe(`${browser.baseUrl}workspaces`);
  });

  it('should display a "launch null capability" button', () => {
    expect(page.getLaunchNullCapabilityButton().getText()).toEqual(
      "Launch null capability"
    );
  });

  it('should display capability request and execution when "launch null capability" button clicked', () => {
    const launchNullCapabilityButton: ElementFinder = element(
      by.css("#launchNullCapabilityBtn")
    );
    browser
      .wait(
        protractor.ExpectedConditions.elementToBeClickable(
          launchNullCapabilityButton
        ),
        5000
      )
      .then(() => {
        launchNullCapabilityButton.click();
      });

    browser.sleep(1000);
    expect(
      page.getCapabilityResults().element(by.css("#request-0")).getText()
    ).toContain("Capability request created: ");
    expect(
      page.getCapabilityResults().element(by.css("#execution-0")).getText()
    ).toContain("Capability execution created: ");
  });

  afterEach(async () => {
    // Assert that there are no errors emitted from the browser
    const logs = await browser.manage().logs().get(logging.Type.BROWSER);
    expect(logs).not.toContain(
      jasmine.objectContaining({
        level: logging.Level.SEVERE,
      } as logging.Entry)
    );
  });
});
